<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `&#x2F;nix&#x2F;store&#x2F;klw0pjcx3gcsqz561gi1wwv8hj1lg84w-vendored-sources&#x2F;generic-array-0.14.5&#x2F;src&#x2F;impls.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>impls.rs - source</title><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../light.css"  id="themeStyle"><link rel="stylesheet" type="text/css" href="../../dark.css" disabled ><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled ><script id="default-settings" ></script><script src="../../storage.js"></script><script src="../../crates.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"><style type="text/css">#crate-search{background-image:url("../../down-arrow.svg");}</style></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="sidebar"><div class="sidebar-menu" role="button">&#9776;</div><a href='../../generic_array/index.html'><div class='logo-container rust-logo'><img src='../../rust-logo.png' alt='logo'></div></a></nav><div class="theme-picker"><button id="theme-picker" aria-label="Pick another theme!" aria-haspopup="menu" title="themes"><img width="18" height="18" alt="Pick another theme!" src="../../brush.svg"></button><div id="theme-choices" role="menu"></div></div><nav class="sub"><form class="search-form"><div class="search-container"><div><select id="crate-search"><option value="All crates">All crates</option></select><input class="search-input" name="search" disabled autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"></div><button type="button" id="help-button" title="help">?</button><a id="settings-menu" href="../../settings.html" title="settings"><img width="18" height="18" alt="Change settings" src="../../wheel.svg"></a></div></form></nav><section id="main" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">  1</span>
<span id="2">  2</span>
<span id="3">  3</span>
<span id="4">  4</span>
<span id="5">  5</span>
<span id="6">  6</span>
<span id="7">  7</span>
<span id="8">  8</span>
<span id="9">  9</span>
<span id="10"> 10</span>
<span id="11"> 11</span>
<span id="12"> 12</span>
<span id="13"> 13</span>
<span id="14"> 14</span>
<span id="15"> 15</span>
<span id="16"> 16</span>
<span id="17"> 17</span>
<span id="18"> 18</span>
<span id="19"> 19</span>
<span id="20"> 20</span>
<span id="21"> 21</span>
<span id="22"> 22</span>
<span id="23"> 23</span>
<span id="24"> 24</span>
<span id="25"> 25</span>
<span id="26"> 26</span>
<span id="27"> 27</span>
<span id="28"> 28</span>
<span id="29"> 29</span>
<span id="30"> 30</span>
<span id="31"> 31</span>
<span id="32"> 32</span>
<span id="33"> 33</span>
<span id="34"> 34</span>
<span id="35"> 35</span>
<span id="36"> 36</span>
<span id="37"> 37</span>
<span id="38"> 38</span>
<span id="39"> 39</span>
<span id="40"> 40</span>
<span id="41"> 41</span>
<span id="42"> 42</span>
<span id="43"> 43</span>
<span id="44"> 44</span>
<span id="45"> 45</span>
<span id="46"> 46</span>
<span id="47"> 47</span>
<span id="48"> 48</span>
<span id="49"> 49</span>
<span id="50"> 50</span>
<span id="51"> 51</span>
<span id="52"> 52</span>
<span id="53"> 53</span>
<span id="54"> 54</span>
<span id="55"> 55</span>
<span id="56"> 56</span>
<span id="57"> 57</span>
<span id="58"> 58</span>
<span id="59"> 59</span>
<span id="60"> 60</span>
<span id="61"> 61</span>
<span id="62"> 62</span>
<span id="63"> 63</span>
<span id="64"> 64</span>
<span id="65"> 65</span>
<span id="66"> 66</span>
<span id="67"> 67</span>
<span id="68"> 68</span>
<span id="69"> 69</span>
<span id="70"> 70</span>
<span id="71"> 71</span>
<span id="72"> 72</span>
<span id="73"> 73</span>
<span id="74"> 74</span>
<span id="75"> 75</span>
<span id="76"> 76</span>
<span id="77"> 77</span>
<span id="78"> 78</span>
<span id="79"> 79</span>
<span id="80"> 80</span>
<span id="81"> 81</span>
<span id="82"> 82</span>
<span id="83"> 83</span>
<span id="84"> 84</span>
<span id="85"> 85</span>
<span id="86"> 86</span>
<span id="87"> 87</span>
<span id="88"> 88</span>
<span id="89"> 89</span>
<span id="90"> 90</span>
<span id="91"> 91</span>
<span id="92"> 92</span>
<span id="93"> 93</span>
<span id="94"> 94</span>
<span id="95"> 95</span>
<span id="96"> 96</span>
<span id="97"> 97</span>
<span id="98"> 98</span>
<span id="99"> 99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
<span id="177">177</span>
<span id="178">178</span>
<span id="179">179</span>
<span id="180">180</span>
<span id="181">181</span>
<span id="182">182</span>
<span id="183">183</span>
<span id="184">184</span>
<span id="185">185</span>
<span id="186">186</span>
<span id="187">187</span>
<span id="188">188</span>
<span id="189">189</span>
<span id="190">190</span>
<span id="191">191</span>
<span id="192">192</span>
<span id="193">193</span>
<span id="194">194</span>
<span id="195">195</span>
<span id="196">196</span>
<span id="197">197</span>
<span id="198">198</span>
<span id="199">199</span>
<span id="200">200</span>
<span id="201">201</span>
<span id="202">202</span>
<span id="203">203</span>
<span id="204">204</span>
<span id="205">205</span>
<span id="206">206</span>
<span id="207">207</span>
<span id="208">208</span>
<span id="209">209</span>
<span id="210">210</span>
<span id="211">211</span>
<span id="212">212</span>
<span id="213">213</span>
<span id="214">214</span>
<span id="215">215</span>
<span id="216">216</span>
<span id="217">217</span>
<span id="218">218</span>
<span id="219">219</span>
<span id="220">220</span>
<span id="221">221</span>
<span id="222">222</span>
<span id="223">223</span>
<span id="224">224</span>
<span id="225">225</span>
<span id="226">226</span>
<span id="227">227</span>
<span id="228">228</span>
<span id="229">229</span>
<span id="230">230</span>
<span id="231">231</span>
<span id="232">232</span>
<span id="233">233</span>
<span id="234">234</span>
<span id="235">235</span>
<span id="236">236</span>
<span id="237">237</span>
<span id="238">238</span>
<span id="239">239</span>
<span id="240">240</span>
<span id="241">241</span>
<span id="242">242</span>
<span id="243">243</span>
<span id="244">244</span>
<span id="245">245</span>
<span id="246">246</span>
<span id="247">247</span>
<span id="248">248</span>
<span id="249">249</span>
<span id="250">250</span>
<span id="251">251</span>
<span id="252">252</span>
<span id="253">253</span>
<span id="254">254</span>
<span id="255">255</span>
<span id="256">256</span>
<span id="257">257</span>
<span id="258">258</span>
<span id="259">259</span>
<span id="260">260</span>
<span id="261">261</span>
<span id="262">262</span>
<span id="263">263</span>
<span id="264">264</span>
<span id="265">265</span>
<span id="266">266</span>
<span id="267">267</span>
<span id="268">268</span>
<span id="269">269</span>
</pre><pre class="rust"><code><span class="kw">use</span> <span class="ident">core::borrow</span>::{<span class="ident">Borrow</span>, <span class="ident">BorrowMut</span>};
<span class="kw">use</span> <span class="ident">core::cmp::Ordering</span>;
<span class="kw">use</span> <span class="ident">core::fmt</span>::{<span class="self">self</span>, <span class="ident">Debug</span>};
<span class="kw">use</span> <span class="ident">core::hash</span>::{<span class="ident">Hash</span>, <span class="ident">Hasher</span>};

<span class="kw">use</span> <span class="kw">super</span>::{<span class="ident">ArrayLength</span>, <span class="ident">GenericArray</span>};

<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::functional</span>::<span class="kw-2">*</span>;
<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::sequence</span>::<span class="kw-2">*</span>;

<span class="kw">impl</span><span class="op">&lt;</span><span class="ident">T</span>: <span class="ident">Default</span>, <span class="ident">N</span><span class="op">&gt;</span> <span class="ident">Default</span> <span class="kw">for</span> <span class="ident">GenericArray</span><span class="op">&lt;</span><span class="ident">T</span>, <span class="ident">N</span><span class="op">&gt;</span>
<span class="kw">where</span>
    <span class="ident">N</span>: <span class="ident">ArrayLength</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span>,
{
    <span class="attribute">#[<span class="ident">inline</span>(<span class="ident">always</span>)]</span>
    <span class="kw">fn</span> <span class="ident">default</span>() <span class="op">-</span><span class="op">&gt;</span> <span class="self">Self</span> {
        <span class="ident"><span class="self">Self</span>::generate</span>(<span class="op">|</span><span class="kw">_</span><span class="op">|</span> <span class="ident">T::default</span>())
    }
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="ident">T</span>: <span class="ident">Clone</span>, <span class="ident">N</span><span class="op">&gt;</span> <span class="ident">Clone</span> <span class="kw">for</span> <span class="ident">GenericArray</span><span class="op">&lt;</span><span class="ident">T</span>, <span class="ident">N</span><span class="op">&gt;</span>
<span class="kw">where</span>
    <span class="ident">N</span>: <span class="ident">ArrayLength</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span>,
{
    <span class="kw">fn</span> <span class="ident">clone</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">GenericArray</span><span class="op">&lt;</span><span class="ident">T</span>, <span class="ident">N</span><span class="op">&gt;</span> {
        <span class="self">self</span>.<span class="ident">map</span>(<span class="ident">Clone::clone</span>)
    }
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="ident">T</span>: <span class="ident">Copy</span>, <span class="ident">N</span><span class="op">&gt;</span> <span class="ident">Copy</span> <span class="kw">for</span> <span class="ident">GenericArray</span><span class="op">&lt;</span><span class="ident">T</span>, <span class="ident">N</span><span class="op">&gt;</span>
<span class="kw">where</span>
    <span class="ident">N</span>: <span class="ident">ArrayLength</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span>,
    <span class="ident">N::ArrayType</span>: <span class="ident">Copy</span>,
{
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="ident">T</span>: <span class="ident">PartialEq</span>, <span class="ident">N</span><span class="op">&gt;</span> <span class="ident">PartialEq</span> <span class="kw">for</span> <span class="ident">GenericArray</span><span class="op">&lt;</span><span class="ident">T</span>, <span class="ident">N</span><span class="op">&gt;</span>
<span class="kw">where</span>
    <span class="ident">N</span>: <span class="ident">ArrayLength</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span>,
{
    <span class="kw">fn</span> <span class="ident">eq</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">other</span>: <span class="kw-2">&amp;</span><span class="self">Self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">bool</span> {
        <span class="kw-2">*</span><span class="kw-2">*</span><span class="self">self</span> <span class="op">=</span><span class="op">=</span> <span class="kw-2">*</span><span class="kw-2">*</span><span class="ident">other</span>
    }
}
<span class="kw">impl</span><span class="op">&lt;</span><span class="ident">T</span>: <span class="ident">Eq</span>, <span class="ident">N</span><span class="op">&gt;</span> <span class="ident">Eq</span> <span class="kw">for</span> <span class="ident">GenericArray</span><span class="op">&lt;</span><span class="ident">T</span>, <span class="ident">N</span><span class="op">&gt;</span> <span class="kw">where</span> <span class="ident">N</span>: <span class="ident">ArrayLength</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span> {}

<span class="kw">impl</span><span class="op">&lt;</span><span class="ident">T</span>: <span class="ident">PartialOrd</span>, <span class="ident">N</span><span class="op">&gt;</span> <span class="ident">PartialOrd</span> <span class="kw">for</span> <span class="ident">GenericArray</span><span class="op">&lt;</span><span class="ident">T</span>, <span class="ident">N</span><span class="op">&gt;</span>
<span class="kw">where</span>
    <span class="ident">N</span>: <span class="ident">ArrayLength</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span>,
{
    <span class="kw">fn</span> <span class="ident">partial_cmp</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">other</span>: <span class="kw-2">&amp;</span><span class="ident">GenericArray</span><span class="op">&lt;</span><span class="ident">T</span>, <span class="ident">N</span><span class="op">&gt;</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">Ordering</span><span class="op">&gt;</span> {
        <span class="ident">PartialOrd::partial_cmp</span>(<span class="self">self</span>.<span class="ident">as_slice</span>(), <span class="ident">other</span>.<span class="ident">as_slice</span>())
    }
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="ident">T</span>: <span class="ident">Ord</span>, <span class="ident">N</span><span class="op">&gt;</span> <span class="ident">Ord</span> <span class="kw">for</span> <span class="ident">GenericArray</span><span class="op">&lt;</span><span class="ident">T</span>, <span class="ident">N</span><span class="op">&gt;</span>
<span class="kw">where</span>
    <span class="ident">N</span>: <span class="ident">ArrayLength</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span>,
{
    <span class="kw">fn</span> <span class="ident">cmp</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">other</span>: <span class="kw-2">&amp;</span><span class="ident">GenericArray</span><span class="op">&lt;</span><span class="ident">T</span>, <span class="ident">N</span><span class="op">&gt;</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">Ordering</span> {
        <span class="ident">Ord::cmp</span>(<span class="self">self</span>.<span class="ident">as_slice</span>(), <span class="ident">other</span>.<span class="ident">as_slice</span>())
    }
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="ident">T</span>: <span class="ident">Debug</span>, <span class="ident">N</span><span class="op">&gt;</span> <span class="ident">Debug</span> <span class="kw">for</span> <span class="ident">GenericArray</span><span class="op">&lt;</span><span class="ident">T</span>, <span class="ident">N</span><span class="op">&gt;</span>
<span class="kw">where</span>
    <span class="ident">N</span>: <span class="ident">ArrayLength</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span>,
{
    <span class="kw">fn</span> <span class="ident">fmt</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">fmt</span>: <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">fmt::Formatter</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">fmt::Result</span> {
        <span class="self">self</span>[..].<span class="ident">fmt</span>(<span class="ident">fmt</span>)
    }
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="ident">T</span>, <span class="ident">N</span><span class="op">&gt;</span> <span class="ident">Borrow</span><span class="op">&lt;</span>[<span class="ident">T</span>]<span class="op">&gt;</span> <span class="kw">for</span> <span class="ident">GenericArray</span><span class="op">&lt;</span><span class="ident">T</span>, <span class="ident">N</span><span class="op">&gt;</span>
<span class="kw">where</span>
    <span class="ident">N</span>: <span class="ident">ArrayLength</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span>,
{
    <span class="attribute">#[<span class="ident">inline</span>(<span class="ident">always</span>)]</span>
    <span class="kw">fn</span> <span class="ident">borrow</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="kw-2">&amp;</span>[<span class="ident">T</span>] {
        <span class="kw-2">&amp;</span><span class="self">self</span>[..]
    }
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="ident">T</span>, <span class="ident">N</span><span class="op">&gt;</span> <span class="ident">BorrowMut</span><span class="op">&lt;</span>[<span class="ident">T</span>]<span class="op">&gt;</span> <span class="kw">for</span> <span class="ident">GenericArray</span><span class="op">&lt;</span><span class="ident">T</span>, <span class="ident">N</span><span class="op">&gt;</span>
<span class="kw">where</span>
    <span class="ident">N</span>: <span class="ident">ArrayLength</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span>,
{
    <span class="attribute">#[<span class="ident">inline</span>(<span class="ident">always</span>)]</span>
    <span class="kw">fn</span> <span class="ident">borrow_mut</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="kw-2">&amp;</span><span class="kw-2">mut</span> [<span class="ident">T</span>] {
        <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>[..]
    }
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="ident">T</span>, <span class="ident">N</span><span class="op">&gt;</span> <span class="ident">AsRef</span><span class="op">&lt;</span>[<span class="ident">T</span>]<span class="op">&gt;</span> <span class="kw">for</span> <span class="ident">GenericArray</span><span class="op">&lt;</span><span class="ident">T</span>, <span class="ident">N</span><span class="op">&gt;</span>
<span class="kw">where</span>
    <span class="ident">N</span>: <span class="ident">ArrayLength</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span>,
{
    <span class="attribute">#[<span class="ident">inline</span>(<span class="ident">always</span>)]</span>
    <span class="kw">fn</span> <span class="ident">as_ref</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="kw-2">&amp;</span>[<span class="ident">T</span>] {
        <span class="kw-2">&amp;</span><span class="self">self</span>[..]
    }
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="ident">T</span>, <span class="ident">N</span><span class="op">&gt;</span> <span class="ident">AsMut</span><span class="op">&lt;</span>[<span class="ident">T</span>]<span class="op">&gt;</span> <span class="kw">for</span> <span class="ident">GenericArray</span><span class="op">&lt;</span><span class="ident">T</span>, <span class="ident">N</span><span class="op">&gt;</span>
<span class="kw">where</span>
    <span class="ident">N</span>: <span class="ident">ArrayLength</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span>,
{
    <span class="attribute">#[<span class="ident">inline</span>(<span class="ident">always</span>)]</span>
    <span class="kw">fn</span> <span class="ident">as_mut</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="kw-2">&amp;</span><span class="kw-2">mut</span> [<span class="ident">T</span>] {
        <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>[..]
    }
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="ident">T</span>: <span class="ident">Hash</span>, <span class="ident">N</span><span class="op">&gt;</span> <span class="ident">Hash</span> <span class="kw">for</span> <span class="ident">GenericArray</span><span class="op">&lt;</span><span class="ident">T</span>, <span class="ident">N</span><span class="op">&gt;</span>
<span class="kw">where</span>
    <span class="ident">N</span>: <span class="ident">ArrayLength</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span>,
{
    <span class="kw">fn</span> <span class="ident">hash</span><span class="op">&lt;</span><span class="ident">H</span><span class="op">&gt;</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">state</span>: <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">H</span>)
    <span class="kw">where</span>
        <span class="ident">H</span>: <span class="ident">Hasher</span>,
    {
        <span class="ident">Hash::hash</span>(<span class="kw-2">&amp;</span><span class="self">self</span>[..], <span class="ident">state</span>)
    }
}

<span class="macro">macro_rules!</span> <span class="ident">impl_from</span> {
    ($(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">n</span>: <span class="ident">expr</span> <span class="op">=</span><span class="op">&gt;</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">ty</span>: <span class="ident">ty</span>),<span class="kw-2">*</span>) <span class="op">=</span><span class="op">&gt;</span> {
        $(
            <span class="kw">impl</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span> <span class="ident">From</span><span class="op">&lt;</span>[<span class="ident">T</span>; <span class="macro-nonterminal">$</span><span class="macro-nonterminal">n</span>]<span class="op">&gt;</span> <span class="kw">for</span> <span class="ident">GenericArray</span><span class="op">&lt;</span><span class="ident">T</span>, <span class="macro-nonterminal">$</span><span class="macro-nonterminal">ty</span><span class="op">&gt;</span> {
                <span class="attribute">#[<span class="ident">inline</span>(<span class="ident">always</span>)]</span>
                <span class="kw">fn</span> <span class="ident">from</span>(<span class="ident">arr</span>: [<span class="ident">T</span>; <span class="macro-nonterminal">$</span><span class="macro-nonterminal">n</span>]) <span class="op">-</span><span class="op">&gt;</span> <span class="self">Self</span> {
                    <span class="kw">unsafe</span> { <span class="macro-nonterminal">$</span><span class="macro-nonterminal">crate::transmute</span>(<span class="ident">arr</span>) }
                }
            }

            <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">relaxed_coherence</span>)]</span>
            <span class="kw">impl</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span> <span class="ident">From</span><span class="op">&lt;</span><span class="ident">GenericArray</span><span class="op">&lt;</span><span class="ident">T</span>, <span class="macro-nonterminal">$</span><span class="macro-nonterminal">ty</span><span class="op">&gt;</span><span class="op">&gt;</span> <span class="kw">for</span> [<span class="ident">T</span>; <span class="macro-nonterminal">$</span><span class="macro-nonterminal">n</span>] {
                <span class="attribute">#[<span class="ident">inline</span>(<span class="ident">always</span>)]</span>
                <span class="kw">fn</span> <span class="ident">from</span>(<span class="ident">sel</span>: <span class="ident">GenericArray</span><span class="op">&lt;</span><span class="ident">T</span>, <span class="macro-nonterminal">$</span><span class="macro-nonterminal">ty</span><span class="op">&gt;</span>) <span class="op">-</span><span class="op">&gt;</span> [<span class="ident">T</span>; <span class="macro-nonterminal">$</span><span class="macro-nonterminal">n</span>] {
                    <span class="kw">unsafe</span> { <span class="macro-nonterminal">$</span><span class="macro-nonterminal">crate::transmute</span>(<span class="ident">sel</span>) }
                }
            }

            <span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span>, <span class="ident">T</span><span class="op">&gt;</span> <span class="ident">From</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> [<span class="ident">T</span>; <span class="macro-nonterminal">$</span><span class="macro-nonterminal">n</span>]<span class="op">&gt;</span> <span class="kw">for</span> <span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">GenericArray</span><span class="op">&lt;</span><span class="ident">T</span>, <span class="macro-nonterminal">$</span><span class="macro-nonterminal">ty</span><span class="op">&gt;</span> {
                <span class="attribute">#[<span class="ident">inline</span>]</span>
                <span class="kw">fn</span> <span class="ident">from</span>(<span class="ident">slice</span>: <span class="kw-2">&amp;</span>[<span class="ident">T</span>; <span class="macro-nonterminal">$</span><span class="macro-nonterminal">n</span>]) <span class="op">-</span><span class="op">&gt;</span> <span class="kw-2">&amp;</span><span class="ident">GenericArray</span><span class="op">&lt;</span><span class="ident">T</span>, <span class="macro-nonterminal">$</span><span class="macro-nonterminal">ty</span><span class="op">&gt;</span> {
                    <span class="kw">unsafe</span> { <span class="kw-2">&amp;</span><span class="kw-2">*</span>(<span class="ident">slice</span>.<span class="ident">as_ptr</span>() <span class="kw">as</span> <span class="kw-2">*</span><span class="kw">const</span> <span class="ident">GenericArray</span><span class="op">&lt;</span><span class="ident">T</span>, <span class="macro-nonterminal">$</span><span class="macro-nonterminal">ty</span><span class="op">&gt;</span>) }
                }
            }

            <span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span>, <span class="ident">T</span><span class="op">&gt;</span> <span class="ident">From</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="kw-2">mut</span> [<span class="ident">T</span>; <span class="macro-nonterminal">$</span><span class="macro-nonterminal">n</span>]<span class="op">&gt;</span> <span class="kw">for</span> <span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="kw-2">mut</span> <span class="ident">GenericArray</span><span class="op">&lt;</span><span class="ident">T</span>, <span class="macro-nonterminal">$</span><span class="macro-nonterminal">ty</span><span class="op">&gt;</span> {
                <span class="attribute">#[<span class="ident">inline</span>]</span>
                <span class="kw">fn</span> <span class="ident">from</span>(<span class="ident">slice</span>: <span class="kw-2">&amp;</span><span class="kw-2">mut</span> [<span class="ident">T</span>; <span class="macro-nonterminal">$</span><span class="macro-nonterminal">n</span>]) <span class="op">-</span><span class="op">&gt;</span> <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">GenericArray</span><span class="op">&lt;</span><span class="ident">T</span>, <span class="macro-nonterminal">$</span><span class="macro-nonterminal">ty</span><span class="op">&gt;</span> {
                    <span class="kw">unsafe</span> { <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="kw-2">*</span>(<span class="ident">slice</span>.<span class="ident">as_mut_ptr</span>() <span class="kw">as</span> <span class="kw-2">*</span><span class="kw-2">mut</span> <span class="ident">GenericArray</span><span class="op">&lt;</span><span class="ident">T</span>, <span class="macro-nonterminal">$</span><span class="macro-nonterminal">ty</span><span class="op">&gt;</span>) }
                }
            }

            <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">not</span>(<span class="ident">relaxed_coherence</span>))]</span>
            <span class="kw">impl</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span> <span class="ident">Into</span><span class="op">&lt;</span>[<span class="ident">T</span>; <span class="macro-nonterminal">$</span><span class="macro-nonterminal">n</span>]<span class="op">&gt;</span> <span class="kw">for</span> <span class="ident">GenericArray</span><span class="op">&lt;</span><span class="ident">T</span>, <span class="macro-nonterminal">$</span><span class="macro-nonterminal">ty</span><span class="op">&gt;</span> {
                <span class="attribute">#[<span class="ident">inline</span>(<span class="ident">always</span>)]</span>
                <span class="kw">fn</span> <span class="ident">into</span>(<span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> [<span class="ident">T</span>; <span class="macro-nonterminal">$</span><span class="macro-nonterminal">n</span>] {
                    <span class="kw">unsafe</span> { <span class="macro-nonterminal">$</span><span class="macro-nonterminal">crate::transmute</span>(<span class="self">self</span>) }
                }
            }

            <span class="kw">impl</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span> <span class="ident">AsRef</span><span class="op">&lt;</span>[<span class="ident">T</span>; <span class="macro-nonterminal">$</span><span class="macro-nonterminal">n</span>]<span class="op">&gt;</span> <span class="kw">for</span> <span class="ident">GenericArray</span><span class="op">&lt;</span><span class="ident">T</span>, <span class="macro-nonterminal">$</span><span class="macro-nonterminal">ty</span><span class="op">&gt;</span> {
                <span class="attribute">#[<span class="ident">inline</span>]</span>
                <span class="kw">fn</span> <span class="ident">as_ref</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="kw-2">&amp;</span>[<span class="ident">T</span>; <span class="macro-nonterminal">$</span><span class="macro-nonterminal">n</span>] {
                    <span class="kw">unsafe</span> { <span class="macro-nonterminal">$</span><span class="macro-nonterminal">crate::transmute</span>(<span class="self">self</span>) }
                }
            }

            <span class="kw">impl</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span> <span class="ident">AsMut</span><span class="op">&lt;</span>[<span class="ident">T</span>; <span class="macro-nonterminal">$</span><span class="macro-nonterminal">n</span>]<span class="op">&gt;</span> <span class="kw">for</span> <span class="ident">GenericArray</span><span class="op">&lt;</span><span class="ident">T</span>, <span class="macro-nonterminal">$</span><span class="macro-nonterminal">ty</span><span class="op">&gt;</span> {
                <span class="attribute">#[<span class="ident">inline</span>]</span>
                <span class="kw">fn</span> <span class="ident">as_mut</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="kw-2">&amp;</span><span class="kw-2">mut</span> [<span class="ident">T</span>; <span class="macro-nonterminal">$</span><span class="macro-nonterminal">n</span>] {
                    <span class="kw">unsafe</span> { <span class="macro-nonterminal">$</span><span class="macro-nonterminal">crate::transmute</span>(<span class="self">self</span>) }
                }
            }
        )<span class="op">*</span>
    }
}

<span class="macro">impl_from!</span> {
    <span class="number">1</span>  <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U1</span>,
    <span class="number">2</span>  <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U2</span>,
    <span class="number">3</span>  <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U3</span>,
    <span class="number">4</span>  <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U4</span>,
    <span class="number">5</span>  <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U5</span>,
    <span class="number">6</span>  <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U6</span>,
    <span class="number">7</span>  <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U7</span>,
    <span class="number">8</span>  <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U8</span>,
    <span class="number">9</span>  <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U9</span>,
    <span class="number">10</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U10</span>,
    <span class="number">11</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U11</span>,
    <span class="number">12</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U12</span>,
    <span class="number">13</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U13</span>,
    <span class="number">14</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U14</span>,
    <span class="number">15</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U15</span>,
    <span class="number">16</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U16</span>,
    <span class="number">17</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U17</span>,
    <span class="number">18</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U18</span>,
    <span class="number">19</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U19</span>,
    <span class="number">20</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U20</span>,
    <span class="number">21</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U21</span>,
    <span class="number">22</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U22</span>,
    <span class="number">23</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U23</span>,
    <span class="number">24</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U24</span>,
    <span class="number">25</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U25</span>,
    <span class="number">26</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U26</span>,
    <span class="number">27</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U27</span>,
    <span class="number">28</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U28</span>,
    <span class="number">29</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U29</span>,
    <span class="number">30</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U30</span>,
    <span class="number">31</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U31</span>,
    <span class="number">32</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U32</span>
}

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;more_lengths&quot;</span>)]</span>
<span class="macro">impl_from!</span> {
    <span class="number">33</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U33</span>,
    <span class="number">34</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U34</span>,
    <span class="number">35</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U35</span>,
    <span class="number">36</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U36</span>,
    <span class="number">37</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U37</span>,
    <span class="number">38</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U38</span>,
    <span class="number">39</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U39</span>,
    <span class="number">40</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U40</span>,
    <span class="number">41</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U41</span>,
    <span class="number">42</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U42</span>,
    <span class="number">43</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U43</span>,
    <span class="number">44</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U44</span>,
    <span class="number">45</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U45</span>,
    <span class="number">46</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U46</span>,
    <span class="number">47</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U47</span>,
    <span class="number">48</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U48</span>,
    <span class="number">49</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U49</span>,
    <span class="number">50</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U50</span>,
    <span class="number">51</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U51</span>,
    <span class="number">52</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U52</span>,
    <span class="number">53</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U53</span>,
    <span class="number">54</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U54</span>,
    <span class="number">55</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U55</span>,
    <span class="number">56</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U56</span>,
    <span class="number">57</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U57</span>,
    <span class="number">58</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U58</span>,
    <span class="number">59</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U59</span>,
    <span class="number">60</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U60</span>,
    <span class="number">61</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U61</span>,
    <span class="number">62</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U62</span>,
    <span class="number">63</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U63</span>,
    <span class="number">64</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U64</span>,

    <span class="number">70</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U70</span>,
    <span class="number">80</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U80</span>,
    <span class="number">90</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U90</span>,

    <span class="number">100</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U100</span>,
    <span class="number">200</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U200</span>,
    <span class="number">300</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U300</span>,
    <span class="number">400</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U400</span>,
    <span class="number">500</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U500</span>,

    <span class="number">128</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U128</span>,
    <span class="number">256</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U256</span>,
    <span class="number">512</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U512</span>,

    <span class="number">1000</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U1000</span>,
    <span class="number">1024</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">::typenum::U1024</span>
}
</code></pre></div>
</section><section id="search" class="content hidden"></section><div id="rustdoc-vars" data-root-path="../../" data-current-crate="generic_array" data-search-index-js="../../search-index.js" data-search-js="../../search.js"></div>
    <script src="../../main.js"></script><script src="../../source-script.js"></script><script src="../../source-files.js"></script>
</body></html>